#include <Bitmap.h>
#include "graphics.h"


MazeBitmap::MazeBitmap( BRect bitmap_rect, unsigned char color )
           :BBitmap( bitmap_rect, B_COLOR_8_BIT ){
	memset( Bits(), color, BitsLength() );
}

void MazeBitmap::Pset( BPoint point, unsigned char color ){
	*((unsigned char *)Bits()+(int)(point.x + point.y * BytesPerRow())) = color;
}

void MazeBitmap::Line( BPoint siten, BPoint syuten, unsigned char color ){
	int ysign = 1, deltax, deltay, dx, dy, x, y, width, counter;
	unsigned char *top;

	if( siten.x > syuten.x ){
		BPoint swap = siten;
		siten = syuten;
		syuten = swap;
	}
	deltax = syuten.x - siten.x;
	deltay = syuten.y - siten.y;
	if( deltay < 0 ){
		ysign = -1;
		deltay = -deltay;
	}
	width = BytesPerRow();
	top = (unsigned char *)Bits();
	if( deltax > deltay ){  /* yokomuki */
		for( dy = deltax/2, x = siten.x, y = siten.y;
			 x <= syuten.x;
			 x++ ){
			dy += deltay;
			if( dy >= deltax ){
				y += ysign;
				dy -= deltax;
			}
			*( top + x + y*width ) = color;
		}
	}else{  /* tatemuki */
		for( dx = deltay/2, x = siten.x, y = siten.y, counter = 0;
			 counter <= deltay;
			 y += ysign, counter++ ){
			dx += deltax;
			if( dx >= deltay ){
				x++;
				dx -= deltay;
			}
			*( top + x + y*width ) = color;
		}
	}		
}

void MazeBitmap::FillEllipse( BPoint center, int xradius, int yradius, unsigned char color ){
}

